/* AJAX */
function mythemes_plg_resources( type ){
    jQuery(function(){
        jQuery.post( ajaxurl , {
            'action' : 'mythemes_plg_resources',
            'type' : type,
            'post_id' : jQuery( 'input#post_ID' ).val()
        }, function( result ){
            jQuery( 'div.mythemes-plg-resource' ).html( result );
        });
    });
}

jQuery(function(){
    
    var keys = {
        8: "backspace", 9: "tab", 13: "return", 16: "shift", 17: "ctrl", 18: "alt", 19: "pause",
        20: "capslock", 27: "esc", 32: "space", 33: "pageup", 34: "pagedown", 35: "end", 36: "home",
        37: "left", 38: "up", 39: "right", 40: "down", 45: "insert", 46: "del",
        96: "0", 97: "1", 98: "2", 99: "3", 100: "4", 101: "5", 102: "6", 103: "7",
        104: "8", 105: "9", 106: "*", 107: "+", 109: "-", 110: ".", 111 : "/",
        112: "f1", 113: "f2", 114: "f3", 115: "f4", 116: "f5", 117: "f6", 118: "f7", 119: "f8",
        120: "f9", 121: "f10", 122: "f11", 123: "f12", 144: "numlock", 145: "scroll", 188: ",", 190: ".",
        191: "/", 224: "meta"
    };

   jQuery('input.mythemes-plg-key-chars').each(function(){
        var input   = this;
        var val     = jQuery( input ).val();
        var preview = jQuery( 'input#' + jQuery( input ).attr('id') + '-key-chars' );
        
        if( val.length ){
            if( keys.hasOwnProperty( val ) ){
                jQuery( preview ).val( keys[ val ] );
            }
            else{
                jQuery( preview ).val( String.fromCharCode( val ).toLowerCase() );
            }
        }
        
        preview.keydown(function(e){
            jQuery( this ).val();
            var code = e.keyCode ? e.keyCode : e.which;
            
            if( keys.hasOwnProperty( code ) ){
                jQuery( this ).val( keys[ code ] );
            }
            else{
                jQuery( this ).val();
                jQuery( this ).focusout();
            }
            jQuery( input ).val( code );
        }).keyup(function(e){
            var code = e.keyCode ? e.keyCode : e.which;
            if( !keys.hasOwnProperty( code ) ){
                jQuery( this ).val( String.fromCharCode( code ).toLowerCase() );
            }
        });
    });
    jQuery('div.mythemes-plg-tabber').each(function(){
        var self = this;
        var current = jQuery( this ).find('div.mythemes-plg-tabber-header nav ul li.current').index();
        var current_cnt = jQuery( jQuery( this ).find('div.mythemes-plg-tabber-content div.mythemes-plg-tabber-item')[ current ] );
        var init_mirror = false;
        
        if( current_cnt.length && !current_cnt.hasClass( 'current' ) ){
            jQuery( this ).find('div.mythemes-plg-tabber-content div.mythemes-plg-tabber-item').removeClass( 'current' );
            current_cnt.addClass( 'current' );
        }
        
        jQuery( this ).find('div.mythemes-plg-tabber-header nav ul li').click(function(){
            var c = jQuery( this ).index();

            jQuery( self ).find('div.mythemes-plg-tabber-header nav ul li').removeClass( 'current' );
            jQuery( this ).addClass( 'current' );
            
            jQuery( self ).find('div.mythemes-plg-tabber-content div.mythemes-plg-tabber-item').removeClass( 'current' );
            var c_cnt = jQuery( jQuery( self ).find('div.mythemes-plg-tabber-content div.mythemes-plg-tabber-item')[ c ] );
            if( c_cnt.length ){
                c_cnt.addClass( 'current' );
                if( c == 2 && !init_mirror ){
                    
                    var editor_on_load = CodeMirror.fromTextArea(document.getElementById( 'mythemes-plg-on-load-page' ), {
                        styleActiveLine: true,
                        lineNumbers: true,
                        lineWrapping: false,
                        matchBrackets: true,
                        mode : "javascript"
                    });

                    var editor_on_start = CodeMirror.fromTextArea(document.getElementById( 'mythemes-plg-on-start' ), {
                        styleActiveLine: true,
                        lineNumbers: true,
                        lineWrapping: false,
                        matchBrackets: true,
                        mode : "javascript"
                    });

                    init_mirror = true;
                }
            }
        })
    });
    
    var type = jQuery( 'div.mythemes-plg-field-res_type select#mythemes-plg-res_type' ).val();
    mythemes_plg_resources( type );
});
